basePath: /api
definitions:
  dto.AvatarOut:
    properties:
      id:
        type: string
      path:
        type: string
    type: object
  dto.BookingCountOut:
    properties:
      count:
        type: integer
    type: object
  dto.BookingCredentials:
    properties:
      email:
        type: string
      name:
        type: string
      participants_count:
        type: integer
    type: object
  dto.BookingInListOut:
    properties:
      email:
        type: string
      name:
        type: string
      participants_count:
        type: integer
    type: object
  dto.BookingListOut:
    properties:
      count:
        type: integer
      items:
        items:
          $ref: '#/definitions/dto.BookingInListOut'
        type: array
    type: object
  dto.EstimationsCountOut:
    properties:
      count:
        type: integer
    type: object
  dto.EstimationsIn:
    properties:
      adrenaline:
        type: boolean
      bad_weather:
        type: boolean
      boring:
        type: boolean
      comfortable:
        type: boolean
      entertainment:
        type: boolean
      interesting:
        type: boolean
      know_everything:
        type: boolean
      know_nothing:
        type: boolean
      not_heard:
        type: boolean
      not_impressed:
        type: boolean
      picturesque:
        type: boolean
      uncomfortable:
        type: boolean
    type: object
  dto.FeedbackIn:
    properties:
      comment:
        type: string
      estimations:
        $ref: '#/definitions/dto.EstimationsIn'
      guide_rating:
        type: integer
      photos:
        items:
          $ref: '#/definitions/dto.FeedbackPhotoIn'
        type: array
      tour_rating:
        type: integer
    type: object
  dto.FeedbackInList:
    properties:
      adrenaline:
        type: boolean
      bad_weather:
        type: boolean
      comfortable:
        type: boolean
      comment:
        type: string
      created_at:
        type: string
      id:
        type: string
      name:
        type: string
      not_impressed:
        type: boolean
      photos:
        items:
          type: string
        type: array
      picturesque:
        type: boolean
      tour_rating:
        type: integer
      uncomfortable:
        type: boolean
    type: object
  dto.FeedbackListOut:
    properties:
      items:
        items:
          $ref: '#/definitions/dto.FeedbackInList'
        type: array
    type: object
  dto.FeedbackPhotoIn:
    properties:
      id:
        type: string
    type: object
  dto.FeedbackPhotoOut:
    properties:
      id:
        type: string
      path:
        type: string
    type: object
  dto.GuideEstimationsOut:
    properties:
      boring:
        $ref: '#/definitions/dto.EstimationsCountOut'
      entertainment:
        $ref: '#/definitions/dto.EstimationsCountOut'
      guide_rating:
        type: number
      interesting:
        $ref: '#/definitions/dto.EstimationsCountOut'
      know_everything:
        $ref: '#/definitions/dto.EstimationsCountOut'
      know_nothing:
        $ref: '#/definitions/dto.EstimationsCountOut'
      not_heard:
        $ref: '#/definitions/dto.EstimationsCountOut'
    type: object
  dto.GuideIn:
    properties:
      bio:
        type: string
      first_name:
        type: string
      last_name:
        type: string
    type: object
  dto.GuideOut:
    properties:
      avatar:
        type: string
      bio:
        type: string
      created_at:
        type: string
      first_name:
        type: string
      id:
        type: string
      last_name:
        type: string
      moderate_status:
        type: string
    type: object
  dto.GuidesListOut:
    properties:
      count:
        type: integer
      items:
        items:
          $ref: '#/definitions/dto.GuideOut'
        type: array
    type: object
  dto.LoginIn:
    properties:
      email:
        type: string
      password:
        type: string
    required:
    - email
    - password
    type: object
  dto.ModerateIn:
    properties:
      comment:
        type: string
      status:
        enum:
        - approved
        - rejected
        type: string
    required:
    - status
    type: object
  dto.PhotoIn:
    properties:
      id:
        type: string
    required:
    - id
    type: object
  dto.PhotoOut:
    properties:
      id:
        type: string
      path:
        type: string
    type: object
  dto.RegistrationIn:
    properties:
      email:
        type: string
      first_name:
        type: string
      last_name:
        type: string
      password:
        type: string
    required:
    - email
    - first_name
    - last_name
    - password
    type: object
  dto.SelfGuideOut:
    properties:
      avatar:
        type: string
      bio:
        type: string
      created_at:
        type: string
      email:
        type: string
      first_name:
        type: string
      id:
        type: string
      last_name:
        type: string
      moderate_status:
        type: string
    type: object
  dto.TagIn:
    properties:
      id:
        type: string
    required:
    - id
    type: object
  dto.TagOut:
    properties:
      id:
        type: string
      title:
        type: string
    type: object
  dto.TagsOut:
    properties:
      tags:
        items:
          $ref: '#/definitions/dto.TagOut'
        type: array
    type: object
  dto.TimeIn:
    properties:
      end_time:
        type: string
      start_time:
        type: string
    required:
    - end_time
    - start_time
    type: object
  dto.TokenIn:
    properties:
      refresh_token:
        type: string
    required:
    - refresh_token
    type: object
  dto.TokensOut:
    properties:
      access_token:
        type: string
      refresh_token:
        type: string
    type: object
  dto.TourCreateIn:
    properties:
      city:
        type: string
      country:
        type: string
      description:
        type: string
      email_message:
        type: string
      max_participants:
        description: 'TODO: complex validation'
        type: integer
      photos:
        items:
          $ref: '#/definitions/dto.PhotoIn'
        type: array
      price:
        type: integer
      short_description:
        type: string
      tags:
        items:
          $ref: '#/definitions/dto.TagIn'
        type: array
      times:
        items:
          $ref: '#/definitions/dto.TimeIn'
        type: array
      title:
        type: string
    required:
    - city
    - country
    - description
    - email_message
    - max_participants
    - price
    - short_description
    - times
    - title
    type: object
  dto.TourEstimationsOut:
    properties:
      adrenaline:
        $ref: '#/definitions/dto.EstimationsCountOut'
      bad_weather:
        $ref: '#/definitions/dto.EstimationsCountOut'
      comfortable:
        $ref: '#/definitions/dto.EstimationsCountOut'
      not_impressed:
        $ref: '#/definitions/dto.EstimationsCountOut'
      picturesque:
        $ref: '#/definitions/dto.EstimationsCountOut'
      tour_rating:
        type: number
      uncomfortable:
        $ref: '#/definitions/dto.EstimationsCountOut'
    type: object
  dto.TourInListOut:
    properties:
      city:
        type: string
      country:
        type: string
      end_time:
        type: string
      id:
        type: string
      photo:
        type: string
      price:
        type: integer
      short_description:
        type: string
      start_time:
        type: string
      title:
        type: string
    type: object
  dto.TourOut:
    properties:
      country:
        type: string
      description:
        type: string
      email_message:
        type: string
      guide_id:
        type: string
      id:
        type: string
      max_participants:
        type: integer
      moderation_status:
        type: string
      photos:
        items:
          $ref: '#/definitions/dto.PhotoOut'
        type: array
      price:
        type: integer
      region:
        type: string
      short_description:
        type: string
      tags:
        items:
          $ref: '#/definitions/dto.TourTagOut'
        type: array
      times:
        items:
          $ref: '#/definitions/dto.TourTimeOut'
        type: array
      title:
        type: string
    type: object
  dto.TourTagOut:
    properties:
      id:
        type: string
      title:
        type: string
    type: object
  dto.TourTimeOut:
    properties:
      end_time:
        type: string
      id:
        type: string
      start_time:
        type: string
    type: object
  dto.ToursListOut:
    properties:
      count:
        type: integer
      items:
        items:
          $ref: '#/definitions/dto.TourInListOut'
        type: array
    type: object
  responses.SuccessOK:
    properties:
      success:
        type: string
    type: object
info:
  contact: {}
  description: Tinkoff Tours API
  title: Tinkoff Tours API
  version: "0.1"
paths:
  /auth/login:
    post:
      consumes:
      - application/json
      description: Login user
      parameters:
      - description: User credentials
        in: body
        name: credentials
        required: true
        schema:
          $ref: '#/definitions/dto.LoginIn'
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/dto.TokensOut'
      summary: Login User
      tags:
      - auth
  /auth/refresh:
    post:
      consumes:
      - application/json
      description: Refresh tokens
      parameters:
      - description: Refresh tokens
        in: body
        name: credentials
        required: true
        schema:
          $ref: '#/definitions/dto.TokenIn'
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/dto.TokensOut'
      summary: Refresh Token
      tags:
      - auth
  /auth/register:
    post:
      consumes:
      - application/json
      description: Registration user
      parameters:
      - description: User credentials
        in: body
        name: credentials
        required: true
        schema:
          $ref: '#/definitions/dto.RegistrationIn'
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/dto.TokensOut'
      summary: Registration user
      tags:
      - auth
  /bookings/{id}:
    delete:
      description: Unbooking tour, send email notification
      parameters:
      - description: Booking ID
        in: path
        name: id
        required: true
        type: string
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/responses.SuccessOK'
      summary: Unbooking tour
      tags:
      - bookings
  /feedbacks/photos:
    delete:
      consumes:
      - application/json
      description: delete photo in feedback
      parameters:
      - description: Photo Data
        in: body
        name: photoData
        required: true
        schema:
          $ref: '#/definitions/dto.FeedbackPhotoIn'
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/responses.SuccessOK'
      summary: Delete photo in feedback
      tags:
      - feedbacks
    post:
      consumes:
      - multipart/form-data
      description: Upload photo to feedback
      parameters:
      - description: Photo File
        in: formData
        name: photo
        required: true
        type: file
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/dto.FeedbackPhotoOut'
      summary: Upload photo to feedback
      tags:
      - feedbacks
  /guide:
    get:
      description: Get tour info
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/dto.SelfGuideOut'
      security:
      - BearerAuth: []
      summary: Get tour
      tags:
      - guide
    put:
      consumes:
      - application/json
      description: Update guide info
      parameters:
      - description: Updated Fields
        in: body
        name: fields
        schema:
          $ref: '#/definitions/dto.GuideIn'
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/dto.GuideOut'
      security:
      - BearerAuth: []
      summary: Update guide info
      tags:
      - guide
  /guide/avatar:
    delete:
      consumes:
      - multipart/form-data
      description: Delete guide avatar
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/dto.AvatarOut'
      security:
      - BearerAuth: []
      summary: Delete guide avatar
      tags:
      - guide
    post:
      consumes:
      - multipart/form-data
      description: Upload guide avatar
      parameters:
      - description: Photo File
        in: formData
        name: avatar
        required: true
        type: file
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/dto.AvatarOut'
      security:
      - BearerAuth: []
      summary: Upload guide avatar
      tags:
      - guide
  /guide/tours:
    get:
      description: Get guide tourService pagination
      parameters:
      - in: query
        minimum: 0
        name: limit
        required: true
        type: integer
      - in: query
        minimum: 0
        name: offset
        required: true
        type: integer
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/dto.ToursListOut'
      security:
      - BearerAuth: []
      summary: Get guide tours
      tags:
      - guide
  /guides/{id}:
    get:
      description: Get guide info
      parameters:
      - description: Guide ID
        in: path
        name: id
        required: true
        type: string
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/dto.GuideOut'
      summary: Get guide info
      tags:
      - guides
  /guides/{id}/estimations:
    get:
      description: Get guide estimations
      parameters:
      - description: Guide ID
        in: path
        name: id
        required: true
        type: string
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/dto.GuideEstimationsOut'
      summary: Get guide estimations
      tags:
      - guides
  /guides/{id}/tours:
    get:
      description: Get tourService by guide with pagination
      parameters:
      - description: Guide ID
        in: path
        name: id
        required: true
        type: string
      - in: query
        minimum: 0
        name: limit
        required: true
        type: integer
      - in: query
        minimum: 0
        name: offset
        required: true
        type: integer
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/dto.ToursListOut'
      summary: Get Tours by guide
      tags:
      - guides
  /moderation/feedbacks:
    get:
      description: Get all feedbacks
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/dto.FeedbackListOut'
      summary: Get all feedbacks
      tags:
      - moderation
  /moderation/guides:
    get:
      description: Get unmoderated guides
      parameters:
      - in: query
        minimum: 0
        name: limit
        required: true
        type: integer
      - in: query
        minimum: 0
        name: offset
        required: true
        type: integer
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/dto.GuidesListOut'
      security:
      - BearerAuth: []
      summary: Get unmoderated guides
      tags:
      - moderation
  /moderation/guides/{id}:
    post:
      description: Moderate guide
      parameters:
      - description: Guide ID
        in: path
        name: id
        required: true
        type: string
      - description: Moderate guide
        in: body
        name: moderateIn
        required: true
        schema:
          $ref: '#/definitions/dto.ModerateIn'
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/responses.SuccessOK'
      security:
      - BearerAuth: []
      summary: Moderate guide
      tags:
      - moderation
  /moderation/tours:
    get:
      description: Get unmoderated tours
      parameters:
      - in: query
        minimum: 0
        name: limit
        required: true
        type: integer
      - in: query
        minimum: 0
        name: offset
        required: true
        type: integer
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/dto.ToursListOut'
      security:
      - BearerAuth: []
      summary: Get unmoderated tours
      tags:
      - moderation
  /moderation/tours/{id}:
    post:
      description: Moderate tour
      parameters:
      - description: Tour ID
        in: path
        name: id
        required: true
        type: string
      - description: Moderate tour
        in: body
        name: moderateIn
        required: true
        schema:
          $ref: '#/definitions/dto.ModerateIn'
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/responses.SuccessOK'
      security:
      - BearerAuth: []
      summary: Moderate tour
      tags:
      - moderation
  /tags:
    get:
      consumes:
      - application/json
      description: Get tags
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/dto.TagsOut'
      summary: Get tags
      tags:
      - tags
  /tours:
    get:
      description: Get tours with filters and pagination
      parameters:
      - in: query
        name: city
        type: string
      - in: query
        name: country
        type: string
      - in: query
        name: end_date
        type: string
      - in: query
        name: end_time
        type: string
      - in: query
        minimum: 0
        name: limit
        required: true
        type: integer
      - in: query
        minimum: 0
        name: offset
        required: true
        type: integer
      - in: query
        name: participants
        type: integer
      - in: query
        name: price_limit
        type: integer
      - in: query
        name: start_date
        type: string
      - in: query
        name: start_time
        type: string
      - collectionFormat: multi
        in: query
        items:
          type: string
        name: tags
        type: array
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/dto.ToursListOut'
      summary: Get Tours
      tags:
      - tours
    post:
      consumes:
      - application/json
      description: Create tour
      parameters:
      - description: Tour data
        in: body
        name: tourData
        required: true
        schema:
          $ref: '#/definitions/dto.TourCreateIn'
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/dto.TourOut'
      security:
      - BearerAuth: []
      summary: Create tour
      tags:
      - tours
  /tours/{id}:
    delete:
      description: Delete tour
      parameters:
      - description: Tour ID
        in: path
        name: id
        required: true
        type: string
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/responses.SuccessOK'
      security:
      - BearerAuth: []
      summary: Delete tour
      tags:
      - tours
    get:
      description: Get tour info
      parameters:
      - description: Tour ID
        in: path
        name: id
        required: true
        type: string
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/dto.TourOut'
      summary: Get tour
      tags:
      - tours
    put:
      consumes:
      - application/json
      description: Update tour
      parameters:
      - description: Tour ID
        in: path
        name: id
        required: true
        type: string
      - description: Tour data
        in: body
        name: tourData
        required: true
        schema:
          $ref: '#/definitions/dto.TourCreateIn'
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/responses.SuccessOK'
      security:
      - BearerAuth: []
      summary: Update tour
      tags:
      - tours
  /tours/{id}/estimations:
    get:
      description: Get tour estimations
      parameters:
      - description: Tour ID
        in: path
        name: id
        required: true
        type: string
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/dto.TourEstimationsOut'
      summary: Get tour estimations
      tags:
      - tours
  /tours/{id}/feedbacks:
    get:
      description: Get tour feedbacks
      parameters:
      - description: Tour ID
        in: path
        name: id
        required: true
        type: string
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/dto.FeedbackListOut'
      summary: Get tour feedbacks
      tags:
      - tours
    post:
      description: Create feedback
      parameters:
      - description: Tour ID
        in: path
        name: id
        required: true
        type: string
      - description: Booking ID
        in: query
        name: booking_id
        required: true
        type: string
      - description: Feedback Data
        in: body
        name: feedbackData
        required: true
        schema:
          $ref: '#/definitions/dto.FeedbackIn'
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/responses.SuccessOK'
      summary: Create feedback
      tags:
      - feedbacks
  /tours/{tour_id}/times/{time_id}/bookings:
    get:
      description: Get bookings items of tour
      parameters:
      - description: Tour ID
        in: path
        name: tour_id
        required: true
        type: string
      - description: Time ID
        in: path
        name: time_id
        required: true
        type: string
      - in: query
        minimum: 0
        name: limit
        required: true
        type: integer
      - in: query
        minimum: 0
        name: offset
        required: true
        type: integer
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/dto.BookingListOut'
      security:
      - BearerAuth: []
      summary: Get bookings items of tour
      tags:
      - bookings
    post:
      consumes:
      - application/json
      description: Booking tour, send email notification
      parameters:
      - description: Tour ID
        in: path
        name: tour_id
        required: true
        type: string
      - description: Time ID
        in: path
        name: time_id
        required: true
        type: string
      - description: Booking Credentials
        in: body
        name: credentials
        required: true
        schema:
          $ref: '#/definitions/dto.BookingCredentials'
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/responses.SuccessOK'
      summary: Booking tour
      tags:
      - bookings
  /tours/{tour_id}/times/{time_id}/bookings/count:
    get:
      description: Get bookings count in tour
      parameters:
      - description: Tour ID
        in: path
        name: tour_id
        required: true
        type: string
      - description: Time ID
        in: path
        name: time_id
        required: true
        type: string
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/dto.BookingCountOut'
      summary: Get bookings count in tour
      tags:
      - bookings
  /tours/photos:
    delete:
      consumes:
      - application/json
      description: delete photo
      parameters:
      - description: Photo Data
        in: body
        name: photoData
        required: true
        schema:
          $ref: '#/definitions/dto.PhotoIn'
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/responses.SuccessOK'
      security:
      - BearerAuth: []
      summary: Delete photo
      tags:
      - tours
    post:
      consumes:
      - multipart/form-data
      description: Upload photo
      parameters:
      - description: Photo File
        in: formData
        name: photo
        required: true
        type: file
      produces:
      - application/json
      responses:
        "200":
          description: OK
          schema:
            $ref: '#/definitions/dto.PhotoOut'
      security:
      - BearerAuth: []
      summary: Upload photo
      tags:
      - tours
securityDefinitions:
  BearerAuth:
    description: Put here "Bearer <your_jwt_token>"
    in: header
    name: Authorization
    type: apiKey
swagger: "2.0"
